/** @file fifo_coverage.cpp
 *  .
 *
 * @author   (chupilko@ispras.ru)
 */

#include <fifo_coverage.h>
#include <fifo_model.h>

namespace cpptesk {
namespace examples {
namespace fifo {

FIFOCoverage::FIFO_FULNESS FIFOCoverage::cov_FF(void) const
{
    switch(fifo.fifo_fulness()) {
        case 0:  return FIFOCoverage::FIFO_FULNESS::I0;
        case 1:  return FIFOCoverage::FIFO_FULNESS::I1;
        case 2:  return FIFOCoverage::FIFO_FULNESS::I2;
        case 3:  return FIFOCoverage::FIFO_FULNESS::I3;
        case 4:  return FIFOCoverage::FIFO_FULNESS::I4;
        case 5:  return FIFOCoverage::FIFO_FULNESS::I5;
        case 6:  return FIFOCoverage::FIFO_FULNESS::I6;
        case 7:  return FIFOCoverage::FIFO_FULNESS::I7;
        case 8:  return FIFOCoverage::FIFO_FULNESS::I8;
        case 9:  return FIFOCoverage::FIFO_FULNESS::I9;
        case 10: return FIFOCoverage::FIFO_FULNESS::I10;
        case 11: return FIFOCoverage::FIFO_FULNESS::I11;
        case 12: return FIFOCoverage::FIFO_FULNESS::I12;
        case 13: return FIFOCoverage::FIFO_FULNESS::I13;
        case 14: return FIFOCoverage::FIFO_FULNESS::I14;
        case 15: return FIFOCoverage::FIFO_FULNESS::I15;
        case 16: return FIFOCoverage::FIFO_FULNESS::I16;
        default: assert(false);
    }
}

void FIFOCoverage::out_cov_FF(void) {
      coverageTracker << FIFOCoverage::cov_FF();
}

}}}
